package com.jdblabs.file.treediff

import com.jdbernard.util.ConsoleProgressBar

public class ConsoleProgressListener implements ProgressListener {

    private ConsoleProgressBar consoleProgressBar
    private def out
    private boolean verbose

    public ConsoleProgressListener(def out, boolean verbose) {
        this.consoleProgressBar = new ConsoleProgressBar(out: out)
        this.out = out
        this.verbose = verbose }

    public void init(File root, int total) {
        out.println "-- ${root.canonicalPath}"
        out.println "   $total files"
        consoleProgressBar.max = total
        consoleProgressBar.update(0, root.name) }

    public void update(File curFile, int curCount) {
        if (verbose) {
            consoleProgressBar.erase()
            out.println "   ${curFile.canonicalPath}" }

        consoleProgressBar.update(curCount, curFile.name) }

    public void finish() {
        consoleProgressBar.erase()
        out.println "" }

}
